<script lang="ts">
  import { getBulls } from "./domain";
  import { sortedByScore } from "./utils";

  export let state: GameState;

  $: players = sortedByScore(state.players);

  let winners: PlayerState[];
  $: {
    let winningScore = players[0]?.score;
    winners = players.filter((p) => p.score === winningScore);
  }
</script>

{#if state.phase.k === "GameComplete"}
  <h3>
    {#if winners.length === 1}
      <gs6-user userid={winners[0].id} /> wins!
    {:else if winners.length > 1}
      {#each winners as player, i}
        {#if i === winners.length - 1}
          <span> and </span>
        {/if}
        <gs6-user userid={player.id} />
        {#if i < winners.length - 2}
          <span>, </span>
        {/if}
      {/each}
      win!
    {/if}
  </h3>
{:else}
  <h3>Another round is starting!</h3>
{/if}

<div class="columns">
  <div>
    <div class="header">&nbsp;</div>
    {#each players as player (player.id)}
      <div class="number cell">
        {players.filter((p) => p.score < player.score).length + 1}
      </div>
    {/each}
  </div>

  <div>
    <div class="header">Player</div>
    {#each players as player (player.id)}
      <div class="cell">
        <gs6-user userid={player.id} />
      </div>
    {/each}
  </div>

  <div class="previous-rounds">
    {#each state.summary as scores, roundIndex}
      <div class="previous-round">
        <div class="header">Round {roundIndex + 1}</div>
        {#each players as player (player.id)}
          <div class="number cell">
            {scores[player.id]}
          </div>
        {/each}
      </div>
    {/each}
  </div>

  <div>
    <div class="latest-round">
      <div class="header">Round {state.summary.length + 1}</div>
      {#each players as player (player.id)}
        <div class="number cell">
          {player.taken.map((c) => getBulls(c)).reduce((a, b) => a + b, 0)}
        </div>
      {/each}
    </div>
  </div>

  <div>
    <div class="total header">Total</div>
    {#each players as player (player.id)}
      <div class="total number cell">
        {player.score}
      </div>
    {/each}
  </div>
</div>

<style>
  h3 {
    text-align: center;
    font-style: italic;
    font-weight: 300;
    margin-top: 1rem;
    margin-bottom: 2rem;
  }

  .columns {
    display: flex;
    flex-direction: row;
  }

  .header {
    white-space: nowrap;
    text-align: center;

    font-weight: 500;
    border-bottom: 1px #aaaa solid;
  }

  .header,
  .cell {
    padding: 0.5em;
  }

  .previous-rounds {
    overflow-x: auto;
    display: flex;
    flex-direction: row;

    max-width: calc(15rem + 1px); /* 1px compensating for left border */
    border-left: 1px #aaaa solid;
  }

  .previous-round {
    width: 5rem;
    flex: none;
  }
  .previous-round:not(:first-child) {
    border-left: 1px #aaaa solid;
  }

  .latest-round {
    border-left: 1px #aaaa solid;
    width: 5rem;
  }

  .total {
    border-left: 1px #aaaa solid;
    width: 5rem;
  }

  .number.cell {
    text-align: center;
  }
</style>
